;-procedure draws smooth shaded line (I mean interpolation 24 bit--
;-color), with float z coord interpolation--------------------------
;-author: Maciej Guba (www.macgub.vxm.pl)-------------------------
;-in : -------------------------------------------------------------
;----- edi - pointer to screen buffer ------------------------------
;----- esi - pointer to Z buffer -----------------------------------
;----- eax - y1, x1 as words integer -------------------------------
;----- ebx - y2, x2 as words integer -------------------------------
;----- xmm0 - lo -> hi - z1, r1, g1, b1 as dword float -------------
;----- xmm1 - lo -> hi - z2, r2, g2, b2 as dword float -------------
;----- ecx  - lo -> hi - size_y, size_x of screen as words integer--
smooth_line_f:
ROUND2 equ 10
.x1	 equ [ebp-2]
.y1	 equ [ebp-4]
.x2	 equ [ebp-6]
.y2	 equ [ebp-8]
.size_x  equ [ebp-10]
.size_y  equ [ebp-12]
.delta_x equ [ebp-14]
.delta_y equ [ebp-16]
.z1	 equ [ebp-32] ; z1, r1, g1, b1
.z2	 equ [ebp-48]
.dz	 equ [ebp-64] ; dz, dr, dg, db
.delta	 equ [ebp-68]
.size_x_d equ [ebp-72]


  push ebp
  sub  esp,128
  mov  ebp,esp
  and  ebp,-16

  mov .y1,eax
  mov .y2,ebx
  mov .size_y,ecx
  sub word  .size_y,1

  movq	   xmm7,.y2
  movq	   xmm4,.y2
  movd	   xmm6,.size_y
  pxor	   xmm5,xmm5
  pshufd   xmm6,xmm6,11100000b
  pcmpgtw  xmm7,xmm6
  pcmpgtw  xmm4,xmm5
  pxor	   xmm4,xmm7
  movq	   xmm5,xmm4
  psrldq   xmm5,4
  pand	   xmm5,xmm4
  movq	   xmm4,xmm5
  psrldq   xmm5,2
  pand	   xmm5,xmm4
  movd	   eax,xmm5
  or	   ax,ax
  jz	  .end_line

  mov	   cx,.y1
  cmp	   cx,.y2
  je	   .horizontal_l
  mov	   cx,.x1
  cmp	   cx,.x2
  je	   .vertical_l
    mov 	ax,.x1
    mov 	bx,.y1
    sub 	ax,.x2
    sub 	bx,.y2
    cwde
    movsx	ebx,bx
    cvtsi2ss	xmm5,eax
    cvtsi2ss	xmm4,ebx
    mov 	.delta_x,ax
    mov 	.delta_y,bx
    andps	xmm5,[abs_mask]
    andps	xmm4,[abs_mask]
    cvtss2si	eax,xmm5
    cvtss2si	ebx,xmm4     ; calc absolute value
    cmp 	ax,bx
    je		.deg45_l	 ; bugs in more vertical and  deg 45
    jl		.more_vertical_l
    jg		.more_horizon_l

  jmp	   .end_line

 .horizontal_l:
  mov	      cx,.x2
  cmp	      cx,.x1
  jg	      @f
  je	      .end_line

  movaps      xmm7,xmm0
  movaps      xmm0,xmm1
  movaps      xmm1,xmm7
  movq	      xmm6,.y2
  pshufd      xmm6,xmm6,11100001b
  movq	      .y2,xmm6
@@:
;  movaps      .z1,xmm0
;  movaps      .z2,xmm1


   mov	       cx,.x2
   sub	       cx,.x1
   movsx       ecx,cx

   cvtsi2ss    xmm2,ecx
   subps       xmm1,xmm0
   shufps      xmm2,xmm2,0
   divps       xmm1,xmm2
;   movaps      .dz,xmm1

    movzx	eax,word .size_x
    movsx	ebx,word .y1  ;.y1 and all coords must be in screen area
			      ; (always positive sign)
    mul 	ebx
    movsx	edx,word .x1
    add 	eax,edx
    shl 	eax,2
    add 	esi,eax
    add 	edi,eax
   ; xmm0 - cur zrgb
 .hdraw:
    movss	xmm7,xmm0
    cmpnltss	xmm7,[esi]
    movd	eax,xmm7
    or		eax,eax
    jnz 	@f
    movss	[esi],xmm0		; actualize Z buffer
    cvtps2dq	xmm7,xmm0
    psrldq	xmm7,4
    packssdw	xmm7,xmm7
    packuswb	xmm7,xmm7
    movd	[edi],xmm7
   @@:
    add 	edi,4
    add 	esi,4
    addps	xmm0,xmm1  ;.dz
    sub 	ecx,1
    jnz 	.hdraw
    jmp 	.end_line

.vertical_l:
  mov	      cx,.y2
  cmp	      cx,.y1
  jg	      @f
  je	      .end_line

  movaps      xmm7,xmm0
  movaps      xmm0,xmm1
  movaps      xmm1,xmm7
  movq	      xmm6,.y2
  pshufd      xmm6,xmm6,11100001b
  movq	      .y2,xmm6
@@:
;  movaps      .z1,xmm0
;  movaps      .z2,xmm1


   mov	       cx,.y2
   sub	       cx,.y1
   movsx       ecx,cx

   cvtsi2ss    xmm2,ecx
   subps       xmm1,xmm0
   shufps      xmm2,xmm2,0
   divps       xmm1,xmm2
;   movaps      .dz,xmm1

    movzx	eax,word .size_x
    movsx	ebx,word .y1  ;.y1 and all coords must be in screen area
			      ; (always positive sign)
    mul 	ebx
    movsx	edx,word .x1
    add 	eax,edx
    shl 	eax,2
    add 	esi,eax
    add 	edi,eax
    movzx	edx,word .size_x
    shl 	edx,2
 .vdraw:
    movss	xmm7,xmm0
    cmpnltss	xmm7,[esi]
    movd	eax,xmm7
    or		eax,eax
    jnz 	@f
    movss	[esi],xmm0		; actualize Z buffer
    cvtps2dq	xmm7,xmm0
    psrldq	xmm7,4
    packssdw	xmm7,xmm7
    packuswb	xmm7,xmm7
    movd	[edi],xmm7
   @@:
    add 	edi,edx
    add 	esi,edx
    addps	xmm0,xmm1  ;.dz
    sub 	ecx,1
    jnz 	.vdraw
    jmp 	.end_line

.deg45_l:
  mov	      cx,.x2
  cmp	      cx,.x1
  jg	      @f
  je	      .end_line

  movaps      xmm7,xmm0
  movaps      xmm0,xmm1
  movaps      xmm1,xmm7
  movq	      xmm6,.y2
  pshufd      xmm6,xmm6,11100001b
  movq	      .y2,xmm6
@@:
;  movaps      .z1,xmm0
;  movaps      .z2,xmm1


   mov	       cx,.x2
   sub	       cx,.x1
   movsx       ecx,cx

   cvtsi2ss    xmm2,ecx
   subps       xmm1,xmm0
   shufps      xmm2,xmm2,0
   divps       xmm1,xmm2
;   movaps      .dz,xmm1

    movzx	eax,word .size_x
    movsx	ebx,word .y1  ;.y1 and all coords must be in screen area
			      ; (always positive sign)
    mul 	ebx
    movsx	edx,word .x1
    add 	eax,edx
    shl 	eax,2
    add 	esi,eax
    add 	edi,eax
    movzx	edx,word .size_x
    mov 	ax,.y2
    add 	edx,1
    cmp 	ax,.y1;.delta_y
    jg		@f
;    sub         edx,2
    neg 	edx
    add 	edx,2

  @@:
    shl 	edx,2
 .45draw:
    movss	xmm7,xmm0
    cmpnltss	xmm7,[esi]
    movd	eax,xmm7
    or		eax,eax
    jnz 	@f
    movss	[esi],xmm0		; actualize Z buffer
    cvtps2dq	xmm7,xmm0
    psrldq	xmm7,4
    packssdw	xmm7,xmm7
    packuswb	xmm7,xmm7
    movd	[edi],xmm7
   @@:
    add 	edi,edx
    add 	esi,edx
    addps	xmm0,xmm1  ;.dz
    sub 	ecx,1
    jnz 	.45draw
    jmp 	.end_line

.more_vertical_l:

  mov	      cx,.y2
  cmp	      cx,.y1
  jg	      @f
  je	      .end_line

  movaps      xmm7,xmm0
  movaps      xmm0,xmm1
  movaps      xmm1,xmm7
  movq	      xmm6,.y2
  pshufd      xmm6,xmm6,11100001b
  movq	      .y2,xmm6
@@:
;  movaps      .z1,xmm0
;  movaps      .z2,xmm1


   mov	       cx,.y2
   sub	       cx,.y1
   movsx       ecx,cx
   mov	       ax,.x2
   sub	       ax,.x1
   cwde
   shl	       eax,ROUND2
   cdq
   idiv        ecx
   mov	       .delta,eax


   cvtsi2ss    xmm2,ecx
   subps       xmm1,xmm0
   shufps      xmm2,xmm2,0
   divps       xmm1,xmm2
;   movaps      .dz,xmm1

    movzx	eax,word .size_x
    movsx	ebx,word .y1  ;.y1 and all coords must be in screen area
			      ; (always positive sign)
    imul	eax,ebx
    movsx	edx,word .x1
    add 	eax,edx
    shl 	eax,2
    add 	esi,eax
    add 	edi,eax

    movzx	edx,word .size_x
    shl 	edx,2
    mov 	.size_x_d,edx
    xor 	ebx,ebx  ; cur x
    xor 	edx,edx
 .mv_draw:
    push	esi
    movss	xmm7,xmm0
    add 	esi,edx
    cmpnltss	xmm7,[esi]
    movd	eax,xmm7
    or		eax,eax
    jnz 	@f
    movss	[esi],xmm0		; actualize Z buffer
    cvtps2dq	xmm7,xmm0
    psrldq	xmm7,4
    packssdw	xmm7,xmm7
    packuswb	xmm7,xmm7
    add 	edx,edi
    movd	[edx],xmm7
   @@:
    add 	ebx,.delta
    pop 	esi
    mov 	edx,ebx
    sar 	edx,ROUND2
    shl 	edx,2
    add 	esi,.size_x_d
    add 	edi,.size_x_d
    addps	xmm0,xmm1  ;.dz
    sub 	ecx,1
    jnz 	.mv_draw
    jmp 	.end_line

.more_horizon_l:

  mov	      cx,.x2
  cmp	      cx,.x1
  jg	      @f
  je	      .end_line

  movaps      xmm7,xmm0
  movaps      xmm0,xmm1
  movaps      xmm1,xmm7
  movq	      xmm6,.y2
  pshufd      xmm6,xmm6,11100001b
  movq	      .y2,xmm6
@@:
;  movaps      .z1,xmm0
;  movaps      .z2,xmm1


   mov	       cx,.x2
   sub	       cx,.x1
   movsx       ecx,cx
   mov	       ax,.y2
   sub	       ax,.y1
   cwde
   shl	       eax,ROUND2
   cdq
   idiv        ecx
;   movzx       edx,word .size_x
;   shl         edx,2
;   imul        edx
   mov	       .delta,eax


   cvtsi2ss    xmm2,ecx
   subps       xmm1,xmm0
   shufps      xmm2,xmm2,0
   divps       xmm1,xmm2
;   movaps      .dz,xmm1

    movzx	eax,word .size_x
    movsx	ebx,word .y1  ;.y1 and all coords must be in screen area
			      ; (always positive sign)
    mul 	ebx
    movsx	edx,word .x1
    add 	eax,edx
    shl 	eax,2
    add 	esi,eax
    add 	edi,eax

    movzx	edx,word .size_x
    shl 	edx,2
;    imul        edx,.delta
    mov 	.size_x_d,edx
    xor 	ebx,ebx  ; cur y
    xor 	edx,edx
 .mh_draw:
    push	esi
    movss	xmm7,xmm0
    add 	esi,edx
    cmpnltss	xmm7,[esi]
    movd	eax,xmm7
    or		eax,eax
    jnz 	@f
    movss	[esi],xmm0		; actualize Z buffer
    cvtps2dq	xmm7,xmm0
    psrldq	xmm7,4
    packssdw	xmm7,xmm7
    add 	edx,edi
    packuswb	xmm7,xmm7
    movd	[edx],xmm7
   @@:
    add 	ebx,.delta
    pop 	esi
    mov 	edx,ebx
    sar 	edx,ROUND2
    imul	edx,.size_x_d
    add 	esi,4 ;.size_x_d
    add 	edi,4 ;.size_x_d
    addps	xmm0,xmm1  ;.dz
    sub 	ecx,1
    jnz 	.mh_draw


.end_line:
     add   esp,128
     pop   ebp
     ret












