

remove_unused_vertices:
; in:
;    eax - triangles (faces) ptr
;    ebx - points (vertices) ptr
;    ecx - triangles (faces) count
;    edx - points (vertices) count
; out:
;    changed points_ptr(ebx) list
;    ecx - new vertices count

    push  ebp
    mov   ebp,esp
    sub   esp,32

  .triangles_ptr	   equ [ebp-4]
  .points_ptr		   equ [ebp-8]
  .triangles_count	   equ [ebp-12]
  .points_count 	   equ [ebp-16]
  .new_vert_with_old_i_ptr equ [ebp-20]
;  .new_tri_list_ptr        equ [ebp-24]
  .points_new_cnt	   equ [ebp-28]

  mov	.triangles_ptr,eax
  mov	.points_ptr,ebx
  mov	.triangles_count,ecx
  mov	.points_count,edx

  movzx   eax,[points_count_var]
  mul	  [i14]
  add	  eax,65536
  invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
  or	  eax,eax
  jnz	  @f
  int3
 @@:
  mov	 .new_vert_with_old_i_ptr,eax

;  movzx   eax,[triangles_count_var]
;  mul     [i6]
;  add     eax,65536
;  invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
;  or      eax,eax
;  jnz     @f
;  int3
; @@:
;   mov    .new_tri_list_ptr,eax

; od zm=0 do points_count rob - sprawdz czy w licie triangles
; jest zm jesli tak pisz dany vertex do listy .new_vert wraz z jego
; starym indeksem zm
;---------
; from zm=0 to points_count do - check if in triangles list
; is zm, if yes, write this vertex with old index zm to .new_vert list

  mov	dword .points_new_cnt,0
  mov	edi,.new_vert_with_old_i_ptr
  xor	eax,eax
  mov	edx,.triangles_count
  lea	edx,[edx*3]
 .find_index:
  mov	esi,.triangles_ptr
  xor	ecx,ecx
 .find:
  cmp	ax,[esi]
  je	.vert_exist
  add	esi,2
  add	ecx,1
  cmp	ecx,edx
  jnz	.find
  jmp	.loop_e ; vertex not exist in triangles list

 .vert_exist:
  mov	 ebx,eax
  shl	 ebx,2
  lea	 ebx,[ebx*3]
  add	 ebx,.points_ptr
  movups xmm0,[ebx]
  movlps  [edi],xmm0
  movhlps xmm0,xmm0
  movss   [edi+8],xmm0
  mov	 [edi+12],ax
  add	 edi,14
  add	 dword .points_new_cnt,1
 .loop_e:
  add	 eax,1
  cmp	 eax,.points_count
  jnz	 .find_index

; in the list pointed by .new_vert..._ptr are new
; vertices and its old index, list pointed by .triangles_ptr
; (.new_tri.._ptr) need renew too, instead old, it will be
; new indexes

  xor  eax,eax
  mov  edx,.triangles_count
  lea  edx,[edx*3]
  mov  edi,.new_vert_with_old_i_ptr
 .find_again:
  mov  bx,[edi+12]
  mov  esi,.triangles_ptr
  xor  ecx,ecx
 .search:
  cmp  [esi],bx
  jne  @f
  mov  [esi],ax
 @@:
  add  esi,2
  add  ecx,1
  cmp  ecx,edx
  jnz  .search
  add  edi,14
  add  eax,1
  cmp  eax,.points_new_cnt
  jnz  .find_again

  mov  esi,.new_vert_with_old_i_ptr    ;copy mem
  mov  edi,.points_ptr
  mov  ecx,.points_new_cnt

 @@:
  movups xmm0,[esi]
  movups [edi],xmm0
  add	 esi,14
  add	 edi,12
  sub	 ecx,1
  jnz	 @b

  invoke  VirtualFree ,.new_vert_with_old_i_ptr,0 , MEM_RELEASE

  mov	ecx,.points_new_cnt

  mov	esp,ebp
  pop	ebp
ret



if 0
; Remove slots - small slits that are side effect of teslate faces
; inside defined area.
;;----
; usun szczeliny -> najpierw przeszukuj liste krawedzi,
; jesli w innej krawedzi jeden z indeksow sie powtarza (ale nie oba),
; licz wektrory jednostkowe tej pierwszej i drugiej krawedzi.
; Jesli ich iloczyn skalarny jest rowny jeden, licz dlugosc
; tych krawedzi. Teraz bierz werteks krotszej krawedzi (tylko
; nie ten opisany przez wspolny indeks) i sprawdz czy lezy on
; miedzy werteksami dluzszej krawedzi. Jesli tak podziel trojkat
; zawierajacy dluzsza krawedz, taki powinien byc tylko jeden
; (choc niekoniecznie); wzdluz krawedzi przebiegajacej od srodka
; dluzszej krawedzi do wierzcholka (werteksu) nie bedacego
; poczatkiem, ani koncem dluzszej krawedzi.
;;----
; remove slots -> at first search in edges list, if in another
; edge index is repeated (but not both), calculate unity
; vectors this first and second edge. If they dot prodduct is
; equal 1.0, calculate lenght both edges. Now take vertex
; of shorter edge (not described by shared index) and check
; if its position is between vertices of longer edge. If yes
; divide triangle that contains longer edge, it should be only
; one such triangle (but not always); along edge, that is described
; from middle of longer edge, to vertex that not be begin,nor end
; of longer edge. (I hope, I described algo anough clear.)
 remove_slots:
; in:
;     eax - ptr to edges
;     ebx - ptr to triangles
;     ecx - edges count
;     edx - ptr to vertices (points)
;     esi - triangles count
;     edi - ypsylon -> senitivity margin
;     memory pointed by ebx, must be enough to write new
;     triangles in it.
; out:
;     ecx - new triangles count

     push  ebp
     mov   ebp,esp
     sub   esp,128
 ;    add   ebp,16
 ;    and   ebp,0xfffffff0
	 .edges_ptr	 equ [ebp-4]
	 .triangles_ptr  equ dword[ebp-8]
	 .edges_count	 equ [ebp-12]
	 .vertices_ptr	 equ dword[ebp-16]
	 .ypsylon	 equ dword[ebp-20]
	 .edges_viewed	 equ dword[ebp-24]
	 .rest_edges	 equ dword[ebp-28]
	 .edge_found	 equ dword[ebp-32]
	 .first_index	 equ dword[ebp-36]  ; index shared by both edges

	 .1sec_index	 equ dword[ebp-40]  ; second ind. shared by both ed.
	 .2sec_index	 equ dword[ebp-44]  ; sec. ind. of longer edge
	 .ed_1st_len	 equ dword[ebp-48]  ; longer edge lenght
	 .ed_2cond_len	 equ dword[ebp-52]  ; shorter edge lenght
	 .third_index	 equ dword[ebp-56]  ; "big" triangle 3rd index
	 .tri_count	 equ dword[ebp-60]
	 .offset1	 equ dword[ebp-64]
	 .tri_counter	 equ dword[ebp-68]

     mov   .edges_ptr,eax
     mov   .triangles_ptr,ebx
     mov   .edges_count,ecx
     mov   .vertices_ptr,edx
     mov   .ypsylon,edi
     mov   .tri_count,esi


   ;  int3
   .search:
    ; int3
     mov    esi,eax
  ;   cmp    eax,.edges_ptr
  ;   jne    @f
  ;   add    esi,4     ; proteza
  ; @@:
     mov    .rest_edges,ecx
     sub    .rest_edges,1

     cmp     ecx,1  ;4
     jle     .the_end
    .search_index:
    @@:
      ; search for similar indexes
   ;  int3
     add      esi,4
     movd     xmm0,[esi]
     movd     xmm1,[eax]
     pcmpeqw  xmm0,xmm1
     pmovmskb  edx,xmm0
     and      edx,0x0000000f
     cmp      edx,0011b  ; less significant word equal?
     je       .lsw

     cmp      edx,1100b  ; most significant word equal?
     je       .msw
     sub      .rest_edges,1
     jnz      @b
     add      eax,4

     sub      ecx,1
     jnz      .search


    .lsw:
     mov      edx,[eax]
     movzx    ebx,dx
     mov      .first_index,ebx	 ; .first_index -> shared index
     shr      edx,16
     mov      .1sec_index,edx	 ; .1sec_index -> index of longer edge
     movzx    ebx,word[esi+2]	 ; .2sec_index -> index of shorter edge
     mov      .2sec_index,ebx
     jmp      .calc_uv
    .msw:
     mov      edx,[eax]
     mov      ebx,edx
     shr      ebx,16
     mov      .first_index,ebx
     movzx    edx,dx
     mov      .1sec_index,edx
     movzx    ebx,word[esi]
     mov      .2sec_index,ebx
   ;  int3
    .calc_uv:			 ; calc unit vectors
     mov      edx,.first_index
     mov      ebx,.1sec_index
     mov      edi,.2sec_index
     shl      edx,2
     shl      ebx,2
     shl      edi,2
     lea      edx,[edx*3]
     lea      ebx,[ebx*3]
     lea      edi,[edi*3]
     add      edx,.vertices_ptr
     add      ebx,.vertices_ptr
     add      edi,.vertices_ptr
     movups   xmm1,[edx]
     movups   xmm2,[ebx]
     movups   xmm3,[edi]
     subps    xmm2,xmm1
     subps    xmm3,xmm1
     andps    xmm2,[zero_hgst_dd]
     andps    xmm3,[zero_hgst_dd]

     movaps   xmm4,xmm2    ; xmm4 = xmm2 = first vector
     movaps   xmm5,xmm3    ; xmm5 = xmm3 = second vector
     mulps    xmm2,xmm2
     mulps    xmm3,xmm3
     haddps   xmm2,xmm2
     haddps   xmm3,xmm3
     haddps   xmm2,xmm2
     haddps   xmm3,xmm3
     sqrtps   xmm2,xmm2    ; xmm2 -> lenght of first vector
     sqrtps   xmm3,xmm3    ; xmm3 -> lenght of second vector
     movss    .ed_1st_len,xmm2
     movss    .ed_2cond_len,xmm3
     rcpps    xmm2,xmm2
     rcpps    xmm3,xmm3
     mulps    xmm4,xmm2
     mulps    xmm5,xmm3
  ;   movaps   xmm2,xmm4    ; xmm4 = xmm2 = first unity vector
  ;   movaps   xmm3,xmm5    ; xmm5 = xmm3 = second unity vctor

     mulps    xmm4,xmm5
     haddps   xmm4,xmm4
     haddps   xmm4,xmm4   ; xmm4 - dot product of 1st and 2cond vector
     mov      edx,0.001   ; check if dot product equal 1.0
     mov      ebx,1.0
     andps    xmm4,[abs_mask] ;broadcasted 0x7fffffff  absolute val
     movd     xmm0,edx
     movd     xmm1,ebx
     movd     xmm2,ebx
     subss    xmm1,xmm0
     addss    xmm2,xmm0
     cmpnltss xmm1,xmm4
     cmpnltss xmm2,xmm4
     xorps    xmm1,xmm2
     pmovmskb  edx,xmm1
     and      edx,0x0000000f
     cmp      edx,0x0000000f ; if equal unity vectors are pararell
			     ; and edges collinear
    ; jz       .search_index
     jnz      .end_loop_s_index
     movss    xmm0,.ed_1st_len
     movss    xmm1,.ed_2cond_len
     cmpnltss xmm0,xmm1
     pmovmskb  edx,xmm0
     and      edx,0x0000000f
     cmp      edx,0x0000000f
     jnz      @f		   ; no exchange
     push     .ed_1st_len
     push     .ed_2cond_len
     pop      .ed_1st_len
     pop      .ed_2cond_len
     push     .1sec_index
     push     .2sec_index
     pop      .1sec_index
     pop      .2sec_index
    @@:
     ; now first edge longer than second

     ; search for third index
 ;    mov      edx,.first_index
     push     .tri_count
     pop      .tri_counter
     mov      edi,.triangles_ptr
   @@:
   .search_edge:
     mov      edx,.first_index
     xor      ebx,ebx
     cmp      [edi],dx
     je       .first_found
     add      ebx,2
     cmp      [edi+ebx],dx
     je       .first_found
     add      ebx,2
     cmp      [edi+ebx],dx
     je       .first_found
     add      edi,6
     sub      .tri_counter,1
     jnz      @b
     jmp      .end_loop_s_index

    .first_found:
     mov     .offset1,ebx
     xor     ebx,ebx
     mov     edx,.1sec_index
     cmp     [edi],dx
     je      .second_found
     add     ebx,2
     cmp     [edi+ebx],dx
     je      .second_found
     add     ebx,2
     cmp     [edi+ebx],dx
     je      .second_found
     sub     .tri_counter,1
     jnz     .search_edge	       ;.end_loop_search
     jmp     .end_loop_s_index	 ;search_edge
    .second_found:
     add     ebx,.offset1
     cmp     ebx,2	     ; offset 0 and 2 first&1sec index
     jne     @f
     movzx   edx,word[edi+4]
     jmp     .th_ind_found
    @@:
     cmp     ebx,4	     ; offset 0 and 4
     jne     @f
     movzx   edx,word[edi+2]
     jmp     .th_ind_found
    @@:
     movzx   edx,word[edi]   ; offset 2 and 4
   .th_ind_found:   ; 3rd index found
     mov     .third_index,edx
   ;  mov     edx,.third_index
     mov     [edi],dx
     mov     edx,.first_index
     mov     [edi+2],dx
     mov     edx,.1sec_index	  ;;;
     mov     [edi],dx

     mov     edi,.tri_count
   ;  add     edi,1
     add     edi,edi
     lea     edi,[edi*3]
     add     edi,.triangles_ptr
     mov     edx,.1sec_index
     mov     [edi],dx
     mov     edx,.third_index
     mov     [edi+2],dx
     mov     edx,.2sec_index
     mov     [edi+4],dx
     add     .tri_count,1
    .end_loop_s_index:
     sub      .rest_edges,1
     jnz      .search_index

    .end_loop_search:
     add      eax,4
     sub      ecx,1
     jnz      .search

   .the_end:
     mov   ecx,.tri_count

     add   esp,128
     pop   ebp
ret
end if




















































































